"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import httpx
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict
from unified_python_sdk.models.shared import storagefile as shared_storagefile
from unified_python_sdk.types import BaseModel
from unified_python_sdk.utils import (
    FieldMetadata,
    PathParamMetadata,
    QueryParamMetadata,
    RequestMetadata,
)


class UpdateStorageFileRequestTypedDict(TypedDict):
    storage_file: shared_storagefile.StorageFileTypedDict
    connection_id: str
    r"""ID of the connection"""
    id: str
    r"""ID of the File"""
    fields: NotRequired[List[str]]
    r"""Comma-delimited fields to return"""


class UpdateStorageFileRequest(BaseModel):
    storage_file: Annotated[
        shared_storagefile.StorageFile,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]

    connection_id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""ID of the connection"""

    id: Annotated[
        str, FieldMetadata(path=PathParamMetadata(style="simple", explode=False))
    ]
    r"""ID of the File"""

    fields: Annotated[
        Optional[List[str]],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Comma-delimited fields to return"""


class UpdateStorageFileResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    storage_file: NotRequired[shared_storagefile.StorageFileTypedDict]
    r"""Successful"""


class UpdateStorageFileResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    storage_file: Optional[shared_storagefile.StorageFile] = None
    r"""Successful"""
